<template>
	<view>
		<view class="block">
			<view class="content">
				<view class="orderinfo">
					<view class="row">
						<view class="nominal">订单金额:</view>
						<view class="text">{{amount}} 元</view>
					</view>
				</view>
			</view>
		</view>
		<view class="block">
			<view class="title">
				选择支付方式
			</view>
			<view class="content">
				<view class="pay-list" v-for="(item,index) in paytypeList" :key="index">
					<view class="row" @tap="paytype='3'" v-if="item == 3">
						<view class="left">
							<image :src="imagewxUrl+imgadres2"></image>
						</view>
						<view class="center">
							汇联通工会卡(余额:{{tongCardPrice}}元)
						</view>
						<view class="right">
							<radio :checked="paytype=='3'" @click="changeRiado()" color="#0083f5" />
						</view>
					</view>
					<!-- <view class="row" @tap="paytype='oilcard'">
						<view class="left">
							<image :src="imagewxUrl+imgadres1"></image>
						</view>
						<view class="center">
							油卡支付(余额:{{oilPirce}}元)
						</view>
						<view class="right">
							<radio :checked="paytype=='oilcard'" @click="changeRiado1()" color="#0083f5" />
						</view>
					</view> -->
					<view class="row" @tap="paytype='4'" v-if="item == 4">
						<view class="left">
							<image src="../../static/img/unionpay.png"></image>
						</view>
						<view class="center">
							银联支付
						</view>
						<view class="right">
							<radio :checked="paytype=='4'" color="#0083f5" />
						</view>
					</view>
				</view>
			</view>
		</view>
		<view class="pay">
			<view class="btn" @tap="orderToPay">立即支付</view>
			<view class="tis">
				点击立即支付，即代表您同意<view class="terms">
					《条款协议》
				</view>
			</view>
		</view>

		<ssPaymentPassword ref="paymentPassword" :mode="1" @submit="submitHandle" />
	</view>
</template>

<script>
	import {
		getHuiLianTongCardBalance,
		oilCardPay,
		findUser,
		qianzhuorderToUnionPay,
		czhltUnionCardPay,
		getThirdPartyByDetail
	} from '../../Utils/Api.js'
	import ssPaymentPassword from '@/components/sanshui-payment-password/index.vue';
	let app = getApp();
	// #ifdef H5
	var jweixin = require('jweixin-module');
	// #endif
	export default {
		components: {
			ssPaymentPassword
		},
		data() {
			return {
				amount: 0,
				imagewxUrl: app.globalData.imageWxImg,
				imgadres: 'wxpay.png',
				imgadres1: 'oilcard.png',
				imgadres2: 'ghkpay.png',
				paytype: '', //支付类型
				orderNo: '',
				user: '', //用户信息
				PaymentPassword: '', //支付密码
				tongCardPrice: 0, //工会卡余额
				oilPirce: 0, //油卡金额
				showType: 3, //支付方式
				paytypeList: [], //支付选择
				productType: '' //分类 星巴克 ，肯德基
			};
		},
		onLoad(e) {
			this.orderNo = e.orderId;
			this.productType = e.productType;
			this.amount = e.amount;
			if (!app.globalData.userInfo) {
				this.findUser()
			}
		},
		onShow() {
			this.user = app.globalData.userInfo;
			this.getThirdPartyByDetail();
			if (app.globalData.userInfo) {
				this.findUser();
			}
		},
		methods: {
			//查询支付方式
			getThirdPartyByDetail() {
				
				let datas = {
					platformId: this.showType,
					regionId: app.globalData.cityId,
					productType: this.productType
				}
				getThirdPartyByDetail(datas).then(res => {
					if (res.return_code == '000000') {
						this.paytypeList = res.return_data.productPayType.split(',');
						this.paytypeList = this.paytypeList.slice(0, this.paytypeList.length - 1);
					}
				});
			},
			//查询我的信息
			findUser() {
				let params;
				findUser(params).then(res => {
					if (res.return_code == '000000') {
						app.globalData.userInfo = res.return_data;
						this.user = res.return_data;
						if (res.return_data.hltCardNo) {
							this.getHuiLianTongCardBalance();
						}
						if (res.return_data.oilCard) {
							this.oilPirce = res.return_data.oilCard.amount;
						}
						uni.setStorage({
							key: "user",
							data: res.return_data
						})
					}
				});
			},
			//获取选择支付方式
			changeRiado() {
				if (!this.user.isSetHltCard) {
					uni.showToast({
						icon: 'none',
						title: '当前账号还未绑定,前往绑定',
						duration: 2000,
						success() {
							setTimeout(() => {
								uni.navigateTo({
									url: '/pages/user/bindingCard/bindingCard'
								})
							}, 1000)
						}
					});
					return;
				}
			},
			//油卡支付
			changeRiado1() {
				if (!this.user.isSetOilCard) {
					uni.showToast({
						icon: 'none',
						title: '当前账号还未绑定,前往绑定',
						duration: 2000,
						success() {
							setTimeout(() => {
								uni.navigateTo({
									url: '/pages/user/bindingCard/bindingCard'
								})
							}, 1000)
						}
					});
					return;
				}
			},
			//查询工会卡余额
			//查询详情
			getHuiLianTongCardBalance() {
				let params = {
					cardNo: this.user.hltCardNo.cardNo
				}
				getHuiLianTongCardBalance(params).then(res => {
					if (res.return_code == '000000') {
						this.tongCardPrice = res.return_data.balance;
					}

				});
			},
			//获取订单数据
			orderToPay() {
				let that = this;
				if (that.paytype == '4') {
					let params = {
						"orderId": that.orderNo
					}
					qianzhuorderToUnionPay(params).then(res => {
						if (res.return_code == '000000') {
								that.uniontopay(res.return_data.prepayid);
						} else {
							uni.showToast({
								title: res.return_msg,
								duration: 2000,
								icon: 'none'
							})
						}
					})
				} else if (that.paytype == '3') {
					if (that.tongCardPrice < that.amount) {
						uni.showToast({
							icon: 'none',
							title: '工会卡余额不足',
							duration: 2000,
						});
						return;
					}
					if (!that.user.isSetPayPwd) {
						uni.navigateTo({
							url: '/pages/login/updatePas/updatePas'
						})
						return;
					}
					if (!that.user.isSetHltCard) {
						uni.showToast({
							icon: 'none',
							title: '当前账号还未绑定,前往绑定',
							duration: 2000,
							success() {
								setTimeout(() => {
									uni.navigateTo({
										url: '/pages/user/bindingCard/bindingCard'
									})
								}, 1000)
							}
						});
						return;
					}
					that.$refs.paymentPassword.modalFun('show');
				} else if (that.paytype == 'oilcard') {
					if (!that.user.isSetPayPwd) {
						uni.navigateTo({
							url: '/pages/login/updatePas/updatePas'
						})
						return;
					}
					if (!that.user.isSetOilCard) {
						uni.showToast({
							icon: 'none',
							title: '当前账号还未绑定,前往绑定',
							duration: 2000,
							success() {
								setTimeout(() => {
									uni.navigateTo({
										url: '/pages/user/bindingCard/bindingCard'
									})
								}, 1000)
							}
						});
						return;
					}
					that.$refs.paymentPassword.modalFun('show');
				} else {
					uni.showToast({
						title: '请选择支付方式',
						icon: 'none',
						duration: 2000
					})
				}
			},
			//银联支付
			uniontopay(item) {
				let that = this;
				upsdk.pluginReady(function() {
					upsdk.pay({
						tn: item,
						success: function(res) {
							uni.showToast({
								title: '支付成功'
							})
							uni.reLaunch({
								url: '/qianzhu-KFC/order-details/order-details?id=' + that.orderNo
							})
						},
						fail: function(err) {
							uni.showToast({
								title: err.msg,
								icon: 'none',
								duration: 2000
							})
							// 支付失败, err.msg 是失败原因描述, 比如TN号不合法, 或者用户取消了交易 等等。
						}
					});
				});
			},
			submitHandle(e) {
				this.PaymentPassword = e.value;
				uni.showLoading({
					title: '支付中...'
				})
				if (this.paytype == '3') {
					let params = {
						"orderId": this.orderNo,
						"cardNo": this.user.hltCardNo.cardNo,
						"password": this.PaymentPassword
					}
					czhltUnionCardPay(params).then(res => {
						uni.hideLoading();
						if (res.return_code == '000000') {
							uni.showToast({
								title: '支付成功'
							})
							uni.reLaunch({
								url: '/qianzhu-KFC/order-details/order-details?id=' + this.orderNo
							})
							return;
						}
						if (res.return_code == '102130') {
							uni.navigateTo({
								url: '/pages/login/updatePas/updatePas'
							})
							return;
						}
						uni.showToast({
							title: res.return_msg,
							icon: 'none'
						})
					})
					return;
				}
				if (this.paytype == 'oilcard') {
					let params = {
						"orderId": this.orderNo,
						"cardNo": this.user.oilCard.cardNo,
						"password": this.PaymentPassword
					}
					oilCardPay(params).then(res => {
						uni.hideLoading();
						if (res.return_code == '000000') {
							uni.showToast({
								title: '支付成功'
							})
							uni.reLaunch({
								url: '/qianzhu-KFC/order-details/order-details?id=' + this.orderNo
							})
							return;
						}
						if (res.return_code == '102130') {
							uni.navigateTo({
								url: '/pages/login/updatePas/updatePas'
							})
							return;
						}
						uni.showToast({
							title: res.return_msg,
							icon: 'none'
						})
					})
					return;
				}
			},
		}
	}
</script>

<style lang="scss">
	.block {
		width: 94%;
		padding: 0 3% 40upx 3%;

		.title {
			width: 100%;
			font-size: 34upx;
		}

		.content {
			.orderinfo {
				width: 100%;
				border-bottom: solid 1upx #eee;

				.row {
					width: 100%;
					height: 90upx;
					display: flex;
					align-items: center;

					.nominal {
						flex-shrink: 0;
						font-size: 32upx;
						color: #7d7d7d;
					}

					.text {
						width: 70%;
						margin-left: 10upx;
						overflow: hidden;
						text-overflow: ellipsis;
						white-space: nowrap;
						font-size: 32upx;
					}
				}
			}

			.pay-list {
				width: 100%;
				border-bottom: solid 1upx #eee;

				.row {
					width: 100%;
					height: 120upx;
					display: flex;
					align-items: center;

					.left {
						width: 100upx;
						flex-shrink: 0;
						display: flex;
						align-items: center;

						image {
							width: 80upx;
							height: 80upx;
						}
					}

					.center {
						width: 100%;
						font-size: 30upx;
					}

					.right {
						width: 100upx;
						flex-shrink: 0;
						display: flex;
						justify-content: flex-end;
					}
				}
			}
		}
	}

	.pay {
		margin-top: 20upx;
		width: 100%;
		display: flex;
		justify-content: center;
		flex-wrap: wrap;

		.btn {
			width: 70%;
			height: 80upx;
			border-radius: 80upx;
			display: flex;
			justify-content: center;
			align-items: center;
			color: #fff;
			background-color: #0083f5;
			box-shadow: 0upx 5upx 10upx rgba(0, 0, 0, 0.2);
		}

		.tis {
			margin-top: 10upx;
			width: 100%;
			font-size: 24upx;
			display: flex;
			justify-content: center;
			align-items: baseline;
			color: #999;

			.terms {
				color: #5a9ef7;
			}
		}
	}
</style>
